#include "GLBody.h"

#include <stdio.h>
#include <iostream>
#include <string>
#include "TransformElement.h"
#include "RotateTransform.h"
#include "TranslateTransform.h"

#include <sstream>
#include <list>

#include "DrawnObject.h"
#include "Parts.h"
#include "CoordinateSystemView.h"

#include "DrawnObjectBySTL.h"
#include <stdlib.h>

#include <math.h>
#include <process.h>




//O[oϐ̎
Parts* GLBody::root;
unsigned int GLBody::threadHandle;



double* degreeTemp;

int mouse_l = 0;
int mouse_m = 0;
int mouse_r = 0;


int mpos[2];


double trans[3] = {0.0, 0.0, 0.0};
double theta[3] = {0.0, 0.0, 0.0};
double angle[3] = {0.0, 0.0, 0.0};




/*
_ύXpϐ

*/

bool isLeftButton;
bool isRightButton;
bool isMiddleButton;

int mousePositionOnClick[2];
double eye[3] = {100,100,400};
double center[3];

double prevEye[3];
double prevCenter[3];
CoordinateSystemView *coordinateSystem;

int mouseDelta[2];


double viewRotX = 30;
double viewRotY = -30;

double viewNorm	= 1000.0;
double viewTheta = 0.5;
double viewFai = 0.0;

double viewScale = 0.5;

double viewOrigin[3];



void GLBody::Display(void){
	//_̏
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();


	glOrtho(-900 , 900 , -900 , 900 , -2000 , 4000);

	double viewThetaTemp = viewTheta + mouseDelta[0]/viewNorm;
	double viewFaiTemp  = viewFai + mouseDelta[1]/viewNorm;
/*
	gluLookAt(viewNorm * sin(viewThetaTemp)*cos(viewFaiTemp) ,viewNorm * sin(viewThetaTemp)*sin(viewFaiTemp) ,
		viewNorm * cos(viewThetaTemp), 0.0f, 00.0f, 0.0f, 0.0f, 1.0f, 0.0f);
*/

	gluLookAt(viewNorm * sin(viewThetaTemp)*cos(viewFaiTemp) -viewOrigin[0],viewNorm * sin(viewThetaTemp)*sin(viewFaiTemp)  -viewOrigin[1],
		viewNorm * cos(viewThetaTemp) -viewOrigin[2],  -viewOrigin[0],  -viewOrigin[1],  -viewOrigin[2], 0.0f, 1.0f, 0.0f);


	glMatrixMode(GL_MODELVIEW);



	//IuWFNg`揈
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	//glClearColor(1.0,1.0,1.0,1.0);
	glClearColor(0.0,0.0,0.0,1.0);
	
	glLoadIdentity();
	//glTranslated(-60,-60,-60);
	//glRotated(angle[0], 1.0, 0.0, 0.0); 
	//glRotated(angle[1], 0.0, 1.0, 0.0);
	//glRotated(angle[2], 0.0, 0.0, 1.0);
	
	//glRotated(viewRotX, 1.0, 0.0, 0.0); 
	//glRotated(viewRotY, 0.0, 1.0, 0.0);
	//glRotated(angle[2], 0.0, 0.0, 1.0);

	glScaled(viewScale,viewScale,viewScale);

	coordinateSystem->Draw(1000);
	if(GLBody::root){
		GLBody::root->ExecuteDrawing();
	}else{

	}
	glutSwapBuffers();
	//viewRotY += 1.0;
}

void mouse(int button, int state, int x, int y){
	switch(button){
	case GLUT_LEFT_BUTTON:
		printf("LEFT");
		if(state == GLUT_DOWN){
			mpos[0] = x;
			mpos[1] = y;
			mouse_l = 1;
		}
		if(state == GLUT_UP){
			mouse_l = 0;
		}
		if(state == GLUT_DOWN){
			isLeftButton = true;
			mousePositionOnClick[0] = x;
			mousePositionOnClick[1] = y;

			prevEye[0] = eye[0];
			prevEye[1] = eye[1];
			prevEye[2] = eye[2];

			prevCenter[0] = center[0];
			prevCenter[1] = center[1];
			prevCenter[2] = center[2];


			printf(" down\n");
		}else if(state == GLUT_UP){
			printf(" up\n");
			isLeftButton = false;
		}
		break;
	case GLUT_RIGHT_BUTTON:
		printf("Right");
		if(state == GLUT_DOWN){
			printf(" down\n");
			isRightButton = true;
			mousePositionOnClick[0] = x;
			mousePositionOnClick[1] = y;
		}else if(state == GLUT_UP){
			printf(" up\n");
			isRightButton = false;
		}
		break;
	case  GLUT_MIDDLE_BUTTON:
		printf("Middle");
		if(state == GLUT_DOWN){
			printf(" down\n");
			mousePositionOnClick[0] = x;
			mousePositionOnClick[1] = y;

			isMiddleButton = true;
		}else if(state == GLUT_UP){
			printf(" up\n");
			isMiddleButton = false;
			viewTheta += mouseDelta[0]/viewNorm;
			viewFai  += mouseDelta[1]/viewNorm;
			
			mouseDelta[0] = 0;
			mouseDelta[1] = 0;

		}
		break;
	default:
		break;
	}
}

void motion(int x, int y){
	if(isMiddleButton){
		mouseDelta[0] = mousePositionOnClick[0]-x;
		mouseDelta[1] = -(mousePositionOnClick[1]-y);
		printf("move %d	%d\n",mouseDelta[0],mouseDelta[1]);
		glutPostRedisplay();

	}else{

	}

	return;

	if(isLeftButton){
		//sړ[h
		printf("Trans\n");
		int deltaX = mousePositionOnClick[0] - x;
		int deltaY = -(mousePositionOnClick[1] - y);

		eye[0] = deltaX + prevEye[0];
		eye[1] = deltaY + prevEye[1];

		center[0] = deltaX + prevCenter[0];
		center[1] = deltaY + prevCenter[1];

		printf("delta %d	%d eye %f %f\n",deltaX,deltaY,eye[0],eye[1]);
		//theta[0] = (double)(y-mousePositionOnClick[1])/5.0;
		//theta[1] = (double)(x-mousePositionOnClick[0])/5.0;
		glutPostRedisplay();
		

	}else if(isMiddleButton){
		//][h

	}
	
	/*
	if(mouse_l == 1){
		theta[0] = (double)(y-mpos[1])/5.0;
		theta[1] = (double)(x-mpos[0])/5.0;
	}
	if(mouse_l == 1 || mouse_m == 1 || mouse_r == 1){
		mpos[0] = x; 
		mpos[1] = y;
		angle[0] += theta[0];
		angle[1] += theta[1];
		glutPostRedisplay();
	}
	*/
}

void reshape(int w, int h){
	//_̏
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glOrtho(-900 , 900 , -900 , 900 , -2000 , 4000);

	double viewThetaTemp = viewTheta + mouseDelta[0]/viewNorm;
	double viewFaiTemp  = viewFai + mouseDelta[1]/viewNorm;

	gluLookAt(viewNorm * sin(viewThetaTemp)*cos(viewFaiTemp) ,viewNorm * sin(viewThetaTemp)*sin(viewFaiTemp) ,
		viewNorm * cos(viewThetaTemp), 0.0f, 00.0f, 0.0f, 0.0f, 1.0f, 0.0f);

	glMatrixMode(GL_MODELVIEW);
}

void specialKey(int key, int x, int y){
	if(key == GLUT_KEY_PAGE_UP){
		viewScale *= 1.1;
	}else if(key == GLUT_KEY_PAGE_DOWN){
		viewScale /= 1.1;
	}else if(key == GLUT_KEY_RIGHT){
		double dx = viewNorm * sin(-viewTheta)*cos(viewFai);

		printf("viewRot	%lf	%lf\n",viewTheta,viewFai);
		viewOrigin[0] += dx;
	}else if(key == GLUT_KEY_LEFT){
		double dx = viewNorm * sin(-viewTheta)*cos(viewFai);
		viewOrigin[0] -= dx;
	}	
}


void GLBody::Init(void){
    GLfloat light_position[] = { 5000.0, 5000.0, 5000.0, 1.0 };

    glLightfv(GL_LIGHT0, GL_POSITION, light_position);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_CULL_FACE); 

	glutReshapeFunc(reshape);
	glutDisplayFunc(GLBody::Display);
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	glutSpecialFunc(specialKey);
	glEnable(GL_NORMALIZE); 
}



void GLBody::KeyboardInput(unsigned char key, int x, int y){
	switch(key){
	case 'o':
		viewRotX += 2;
		break;
	case 'k':
		viewRotX -= 2;
		break;
	case 'p':
		viewRotY += 2;
		break;
	case 'l':
		viewRotY -= 2;
		break;
	}	
	GLBody::Display();
}







/**
* (!!)GLUTɂĐꂽEChE
*
*/
void GLBody::Kill(void){
	//glutMainLoop()𔲂@l
}






/**
* `悷Ώۂo^
*
* @param[in] *parts `悷ΏہDʂParserŐpartsc[n 
*/
void GLBody::RegisterPartsGraph(Parts *parts){
	GLBody::root = parts;
}


/**
* `悷Ώۂ폜
*/
void GLBody::UnregisterPartsGraph(void){
	GLBody::root = NULL;
}



/**
* GLUTɂ`揈Jn
*
* ̃\bhĂԂƋAĂȂ(glutMainLoop()gĂ邽)
* 
* @param[in] dummy _beginthreadx̌^ɂ킹邽߂̂́DlɈӖ͖
* @retval 0 ԂėȂ̂ňӖ͖
*/
unsigned int __stdcall GLBody::StartGLUT(void *dummy){
	coordinateSystem = new CoordinateSystemView(10);

	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(800, 800);
	glutCreateWindow("Robot Motion Monitor RTC");
	glutKeyboardFunc(GLBody::KeyboardInput);

	glutIdleFunc(GLBody::Display);
	GLBody::Init();
	glutMainLoop();
	return 0;
}


/**
* GLUTɂ`揈Jn
*
* `悷邽߂̃Xbh𐶐
*
* @retval true Xbhɐ
* @retval false XbhɎs
*/
bool GLBody::Run(void){

	//Windows̍@ŃXbh
	GLBody::threadHandle = _beginthreadex(NULL,0,GLBody::StartGLUT,NULL,0,NULL);
	if(GLBody::threadHandle == 0){
		return false;
	}
	return true;
}