#pragma once

#include <string>
#include <list>
#include <map>
#include "TransformElement.h"
#include "DrawnObject.h"
#include <iostream>
#include "Transform.h"
#include <sstream>
#include <gl/glut.h>


/**
* `悷f[^p[cԂ̐eq֌WCf̕`ɕKvȃf[^ێNXD
* 
*/
class Parts{
public:
	/**
	* qp[cւ̕ێNX
	*
	**/
	class OutputPath{
	public:
		//o
		Transform* outputTrans;
		std::string childName;

		//RXgN^ƃfXgN^
		OutputPath(std::string pathName);
		~OutputPath(void);

		//\bh
		void Dump(void);
		void Dump(int depth ,std::stringstream &ret);
	
		void RegisterChild(Parts *child);
		void UnregisterChild(void);
	
		std::string GetPathName(void);
		void SetPathName(std::string newName);

		bool IsRegisterdChild(void);
		void ExecuteNext(void);

		Parts *next;

	private:
		std::string pathName;
	};

	//^`
	typedef std::map<std::string,Parts::OutputPath*>::iterator OutputPathIterator;

	//o
	std::map<std::string,Parts::OutputPath*> outputs;
	Transform *inputTrans;		//͕̕ϊs񃊃Xg

	DrawnObject* drawnObject;


	//RXgN^ƃfXgN^
	Parts(std::string partsName);
	Parts(void);
	~Parts(void);


	//\bh
	Parts::OutputPath *CreateOutputPath(std::string newPathName);
	void Dump(void);
	void Dump(int depth,std::stringstream &ret);

	void ExecuteDrawing(void);

	std::string GetName(void);
	void SetName(std::string newName);

	std::string GetFilePath(void);
	void SetFilePath(std::string path);


private:
	std::string partsName;
	std::string filePath;
};
